'Lawson Labs, Inc.
'15 Phoenixville Pike
'Malvern, PA  19355                                     June 28, 1995
'800 321-5355  610 725-8800                             version 0
'                                                    
'  141GRF.BAS  Model 141 real-time graphics demonstration code
'
 KEY OFF: CLS
 BP% = 128                      ' BIPOLAR MODE (0 for unipolar)
 CC% = 0                        ' default output control code (0 - 15)
 CHANNEL0% = 1: CHANNEL1% = 0   ' initialize channels
 ADC% = &H230                   ' default port address
 PLOTRATE = 10: PLOTINTERVAL = .1       ' initialize rate and interval
 AVG% = 1                       ' default averaging 1
 ' initialize graphics display variables
 POSFS = 5: NEGFS = -5          ' positive and negative full scale (in volts)
 VDIV = 1                       ' vertival index (in volts)
 HDIV = 0                       ' horizontal index is set by GETHINDEX
  
CONFIGMENU:
  CLS
  LOCATE 6, 22: PRINT "141 CONFIGURATION MENU"
  LOCATE 10, 20: PRINT "0) Channel 0               ";
  IF CHANNEL0% = 1 THEN PRINT "ON" ELSE PRINT "OFF"
  LOCATE 12, 20: PRINT "1) Channel 1               ";
  IF CHANNEL1% = 1 THEN PRINT "ON" ELSE PRINT "OFF"
  LOCATE 14, 20
  IF PLOTRATE >= 1 THEN
    PRINT USING "2) Plot Rate                ##.# Hz"; PLOTRATE
  ELSE
    PRINT USING "2) Plot Interval         #####.## seconds"; PLOTINTERVAL
  END IF
  LOCATE 16, 20: PRINT USING "3) Averaging              ####"; AVG%
  LOCATE 18, 20: PRINT USING "4) Port Address           ####"; ADC%
  LOCATE 20, 16: PRINT "Enter) Start";
  LOCATE 22, 18: PRINT "Esc) Exit program";
  A$ = INPUT$(1)
 
  IF A$ = "0" THEN                      ' toggle channel 0
    IF CHANNEL0% = 1 THEN CHANNEL0% = 0 ELSE CHANNEL0% = 1
  END IF
  IF A$ = "1" THEN                      ' toggle channel 1
    IF CHANNEL1% = 1 THEN CHANNEL1% = 0 ELSE CHANNEL1% = 1
  END IF
  IF A$ = "2" THEN GOSUB GETINTERVAL    ' select data plotting interval
  IF A$ = "3" THEN GOSUB GETAVG         ' get averaging
  IF A$ = "4" THEN GOSUB GETADC         ' get port address
  IF A$ = CHR$(27) THEN END
  IF A$ <> CHR$(13) THEN GOTO CONFIGMENU
  IF (CHANNEL0% + CHANNEL1%) = 0 THEN GOTO CONFIGMENU   ' no channels active
 
  GOSUB CHECK141                        ' check for presence of 141 at port
  CLS : CH% = 0
  IF (CHANNEL0% = 1) AND (CHANNEL1% = 1) THEN
    TOGGLE% = 1                         ' flag toggle channels
  ELSE
    TOGGLE% = 0                         ' one active channel
    IF CHANNEL1% = 1 THEN CH% = 1
  END IF

  Filename$ = "": LOGGING% = 0
  CLS : LOCATE 13, 20: PRINT "Enter name for disk file,"
  LOCATE 15, 20: INPUT "or just enter for no file "; Filename$
  IF Filename$ <> "" THEN LOGGING% = 1: OPEN Filename$ FOR APPEND AS #3
  GOSUB CALIBRATE

  FIRSTIN% = 0                          ' flag for start of scan timer
  STARTDAY$ = DATE$: DAYS = 0
  SCANCNT& = 0
STARTGRAPH:
  GOSUB SETUPSCREEN                     ' set up graphic screen
  IF FIRSTIN% = 0 THEN
    SCANSTART = TIMER: FIRSTIN% = 1     ' the first scan begins
    GOSUB GETELAPSED
    SETTLE = ELAPSEDTIME + SETTLETIME   ' start settling time for channel
  END IF
FirstPoint:
  FIRSTSCAN% = -1                       ' flag first point on screen
  LINE (S%, 0)-(S%, 399), 0
  WHILE S% <> 639                       ' while not to right edge of screen
  COLOR 7
WAITUNTILTIME:
    A$ = UCASE$(INKEY$)
    IF A$ <> "" THEN GOTO DOCOMMAND
KEYPROCESSED:
    GOSUB GETELAPSED                    ' get ELAPSEDTIME
    IF (ELAPSEDTIME / PLOTINTERVAL) < SCANCNT& THEN GOTO WAITUNTILTIME
    S% = S% + 1: SCANCNT& = SCANCNT& + 1
    LOCATE 29, 7: PRINT USING "#######  "; SCANCNT&;
    IF LOGGING% THEN PRINT #3, USING "#####.## "; ELAPSEDTIME;
    IF ELAPSEDTIME / PLOTINTERVAL > SCANCNT& + 1 THEN
      COLOR 15: LOCATE 30, 35: PRINT "DATA MISSED";
    END IF
    LINE (S% + 1, 0)-(S% + 1, 399), 0   ' draw vertical black line
    IF (S% + 1) / HINDEX% = INT((S% + 1) / HINDEX%) THEN   ' redraw ticks
      FOR NK% = 0 TO 399 STEP VINDEX&: PSET (S% + 1, NK%), 15: NEXT NK%
    END IF
    LINE (S% + 2, 0)-(S% + 2, 399), 1   ' draw position line
    GOSUB VOLTDISPLAY                   ' get and display voltage(s) on graph
    FIRSTSCAN% = 0                      ' flag not first point on screen
  WEND                                  ' continue until right edge of screen
  S% = 1                                ' reset screen position counter
  LINE (1, 0)-(1, 399), 0               ' draw vertical black line
  LINE (2, 0)-(2, 399), 0               ' draw vertical black line
  GOTO FirstPoint                       ' wrap to left edge of screen

VOLTDISPLAY:                            ' get and display voltage(s) on graph
  IF TOGGLE% = 0 THEN                   ' if TOGGLE% = 0 then only one channel
    OLDCH% = CH%                        ' set old channel
    GOSUB GETVOLTS                      ' get voltage on current channel
    GOSUB DISPVOLTS                     ' display current channel voltage
  ELSE                                  ' if TOGGLE% = 1 then both channels
    OLDCH% = CH%                        ' set old channel
    GOSUB WAITSETTLE                    ' wait settling time for channel 0
    GOSUB GETVOLTS                      ' get channel 0 voltage
    CH% = 1                             ' toggle to channel 1
    OUT ADC%, CH% * 16 + BP% + CC%      ' select the new channel
    GOSUB GETELAPSED                    ' get ELAPSEDTIME
    SETTLE = ELAPSEDTIME + SETTLETIME   ' start settling time for channel 1
    GOSUB DISPVOLTS                     ' display channel 0
    OLDCH% = CH%                        ' set old channel
    GOSUB WAITSETTLE                    ' wait settling time for channel 0
    GOSUB GETVOLTS                      ' get channel 1 voltage
    CH% = 0                             ' go back to channel 0
    OUT ADC%, CH% * 16 + BP% + CC%      ' select the new channel
    GOSUB GETELAPSED                    ' get ELAPSEDTIME
    SETTLE = ELAPSEDTIME + SETTLETIME   ' start settling time for channel 0
    GOSUB DISPVOLTS                     ' display channel 1 voltage
  END IF
  IF LOGGING% THEN PRINT #3, ""
RETURN

GETVOLTS:
  H = 0: M = 0: L = 0
  FOR N = 1 TO AVG%                     ' average loop counter
NOTREADY:
    IF INP(ADC% + 3) > 127 THEN GOTO NOTREADY     ' wait until done
    OUT ADC% + 1, 1                     ' assert freeze
    H = H + (INP(ADC% + 2) AND &HF)     ' get the 4 most significant bits
    M = M + INP(ADC% + 1)               ' get middle byte
    L = L + INP(ADC%)                   ' get low byte
    OUT ADC% + 1, 0                     ' unset freeze
  NEXT N                                ' get next data for averaging
  COUNT! = L / AVG% + (M / AVG%) * 256 + (H / AVG%) * 65536! ' merge counts
  VOLTS = COUNT! * 9.536743E-06 - 5                     ' convert to volts
  IF BP% = 0 THEN VOLTS = COUNT! * 4.768372E-06         ' for unipolar
RETURN

DISPVOLTS:
  SCOLOR = 10 + OLDCH%                  ' select color for display
  IF LOGGING% THEN PRINT #3, USING "#####.### "; VOLTS * 1000;
  IF VOLTS < POSFS AND VOLTS > NEGFS THEN               ' is voltage on scale?
    VOLTS% = (VOLTS - POSFS) * (399 / (NEGFS - POSFS))  ' calculate y location
  ELSE      'if off scale, set to max/min
    IF VOLTS > POSFS THEN VOLTS% = 0 ELSE VOLTS% = 399
  END IF
  IF FIRSTSCAN% THEN VOLTY%(OLDCH%) = VOLTS%
  LINE (S% - 1, VOLTY%(OLDCH%))-(S%, VOLTS%), SCOLOR    ' plot it
  VOLTY%(OLDCH%) = VOLTS%                       ' save current y location
  LOCATE 27, 5 + 14 * OLDCH%
  COLOR SCOLOR: PRINT USING "######.###"; VOLTS * 1000; ' print voltage
RETURN

DOCOMMAND:
    IF A$ = "E" THEN CLOSE : GOTO EXITSCAN       ' press "E" to end
    IF A$ = "P" THEN
      LOCATE 30, 1: PRINT "Enter positive full scale (mv) ";
      GOSUB GETINPUT: POSFS$ = KEYINPUT$
      IF POSFS$ <> "" THEN      ' reset screen with new positive full scale
        IF VAL(POSFS$) > (NEGFS * 1000) THEN
          POSFS = VAL(POSFS$) / 1000: GOTO STARTGRAPH
        END IF
      END IF
      LOCATE 30, 1: PRINT SPACE$(70);
    END IF
 
    IF A$ = "M" THEN
      LOCATE 30, 1: PRINT "Enter negative full scale (mv) ";
      GOSUB GETINPUT: NEGFS$ = KEYINPUT$
      IF NEGFS$ <> "" THEN      ' reset screen with new negative full scale
        IF VAL(NEGFS$) < (POSFS * 1000) THEN
          NEGFS = VAL(NEGFS$) / 1000: GOTO STARTGRAPH
        END IF
      END IF
      LOCATE 30, 1: PRINT SPACE$(70);
    END IF
 
    IF A$ = "H" THEN
      LOCATE 30, 1: PRINT "Enter horizontal index (seconds) ";
      GOSUB GETINPUT: HDIV$ = KEYINPUT$
      IF HDIV$ <> "" AND VAL(HDIV$) > 0 THEN    ' reset screen with
        HDIV = VAL(HDIV$): GOTO STARTGRAPH      ' new horizontal index
      ELSE
        LOCATE 30, 1: PRINT SPACE$(70);
      END IF
    END IF
 
    IF A$ = "V" THEN
      LOCATE 30, 1: PRINT "Enter vertical index (mv) ";
      GOSUB GETINPUT: VDIV$ = KEYINPUT$
      IF VDIV$ <> "" AND VAL(VDIV$) > 0 THEN            ' reset screen with
        VDIV = VAL(VDIV$) / 1000: GOTO STARTGRAPH       ' new vertical index
      ELSE
        LOCATE 30, 1: PRINT SPACE$(70);
      END IF
    END IF
GOTO KEYPROCESSED              ' done docommand

SETUPSCREEN:
 CLS
 S% = 1: TSCREEN = 639 * PLOTINTERVAL         ' TSCREEN = time for one screen
 VOLTS% = 0: VOLTY%(0) = 0: VOLTY%(1) = 0
ON ERROR GOTO NoVGA
 SCREEN 12      '640 x 400  = horizontal, vertical 1,1 = upper left
ON ERROR GOTO 0
 PALETTE 3, (0 * 65536 + 35 * 256 + 63)         ' create orange color, color 3
 LINE (0, 0)-(0, 400), 2                        ' vertical axis
 IF VDIV <= 0 THEN VDIV = 1                     ' check bounds for VDIV
 IF NEGFS >= POSFS THEN POSFS = NEGFS + 1   ' check bounts for NEGFS and POSFS
 VINDEX& = (399 / (ABS(POSFS - NEGFS) / VDIV))
 IF VINDEX& > 399 THEN VINDEX& = 399            ' check bounds on VINDEX&
 IF VINDEX& < 1 THEN VINDEX& = 1
 FOR N% = 0 TO 399 STEP VINDEX&
   LINE (0, N% - 1)-(0, N% + 1), 15             ' index vertical axis
 NEXT N%
  LINE (1, 400)-(640, 400), 2                   ' horizontal axis
  IF HDIV = 0 THEN                              ' initialize HINDEX% and HDIV
    GOSUB GETHINDEX
  ELSE
    HINDEX% = 639 / (TSCREEN / HDIV): HSEC = HDIV
  END IF
  IF HINDEX% > 639 THEN HINDEX% = 639            ' check bounds on HINDEX%
  IF HINDEX% < 1 THEN HINDEX% = 1
  FOR N% = 0 TO 639 STEP HINDEX%
    FOR NK% = 0 TO 399 STEP VINDEX&
      PSET (N%, NK%), 15                        ' index marks on screen
    NEXT NK%
    LINE (N% - 1, 400)-(N% + 1, 400), 15        ' index horizontal axis
  NEXT N%

  ' display labels and menu options
  COLOR 10: LOCATE 27, 1: PRINT "0=";
  COLOR 11: LOCATE 27, 17: PRINT "1=";
  COLOR 7: LOCATE 27, 40: PRINT "AVERAGING = "; AVG%;
  LOCATE 28, 1: COLOR 7: PRINT USING "######.### sec/screen"; TSCREEN;
  LOCATE 28, 28: COLOR 3: PRINT "P";
  COLOR 7: PRINT USING "lus  FS ######.### mv  "; POSFS * 1000;
  LOCATE 28, 55: COLOR 3: PRINT "H";
  COLOR 7: PRINT USING "oriz #####.### sec/div"; HSEC;
  LOCATE 29, 1: PRINT "SCAN #";
  LOCATE 29, 20: COLOR 3: PRINT "E";
  COLOR 7: PRINT "xit";
  LOCATE 29, 28: COLOR 3: PRINT "M";
  COLOR 7: PRINT USING "inus FS ######.### mv"; NEGFS * 1000;
  LOCATE 29, 55: COLOR 3: PRINT "V";
  COLOR 7: PRINT USING "ert ######.### mv/div"; VDIV * 1000;
RETURN

GETHINDEX:                                      ' calculate inital HINDEX
  HSEC = .1
RETRY: HSEC = HSEC * 10: IF TSCREEN / HSEC > 40 THEN GOTO RETRY
DONEHINDEX:
  HINDEX% = 639 / (TSCREEN / HSEC)
RETURN

GETINPUT:       ' Numeric input until Enter is pressed
KEYINPUT$ = ""
GETNEXTKEY:
  S$ = INPUT$(1)
  IF S$ = CHR$(13) THEN RETURN
  S = ASC(S$)
  IF S = 8 THEN GOSUB BACKSPACE
                   ' get char between "." and "9" but not "," or "/"
  IF (S >= 43 AND S <= 57) AND S <> 44 AND S <> 47 THEN
    KEYINPUT$ = KEYINPUT$ + S$: PRINT S$;
  END IF
GOTO GETNEXTKEY

BACKSPACE:
  IF LEN(KEYINPUT$) > 0 THEN
    KEYINPUT$ = LEFT$(KEYINPUT$, LEN(KEYINPUT$) - 1)   ' one less character
    LOCATE CSRLIN, (POS(0) - 1): PRINT " "; : LOCATE CSRLIN, (POS(0) - 1)
  END IF
RETURN

NoVGA:
  CLS : PRINT " VGA Video required": END
 
EXITSCAN:
  SCREEN 0                                      ' reset screen
  GOTO CONFIGMENU

CALIBRATE:                         ' begin cal routines
  LOCATE 25, 30: PRINT "Calibrating";
  OUT ADC% + 1, 1                  ' freeze
  OUT ADC%, 48 + BP%               ' offset calibration
  OUT ADC%, 48 + 64 + BP%          ' set calibration bit
  START = TIMER                    ' remember the time
  OUT ADC%, 48 + BP%               ' clear calibration bit
  OUT ADC% + 1, 0                  ' unset freeze
FINISHFREEZE:
  IF INP(ADC% + 3) > 127 THEN GOTO FINISHFREEZE 'wait until done
  OUT ADC% + 1, 1                  ' freeze
  OUT ADC%, 32 + BP%               ' fullscale calibration
  OUT ADC%, 32 + 64 + BP%          ' set calibration bit
  OUT ADC%, 32 + BP%               ' clear calibration bit
  OUT ADC% + 1, 0                  ' unfreeze
DONEFREEZE:
  IF INP(ADC% + 3) > 127 THEN GOTO DONEFREEZE   ' wait until done
  IF TIMER > 86390! THEN GOTO DONEFREEZE        ' avoid midnight
  CALTIM = TIMER - START        ' compute time required for calibration
  OUT ADC%, CH% * 16 + BP%      ' select channel
  IF CALTIM >= 5 THEN SETTLETIME = 2.3           ' jumper position 1
  IF (CALTIM > 1.5 AND CALTIM < 5) THEN SETTLETIME = .57 ' jumper position 2
  IF CALTIM <= 1.5 THEN SETTLETIME = .15    ' jumper position 3
  GOSUB GETELAPSED                      ' get ELAPSEDTIME
  SETTLE = ELAPSEDTIME + SETTLETIME     ' start settling time for channel
  GOSUB WAITSETTLE                      ' wait settling time
RETURN                                  ' end of calibration

GETINTERVAL:                            ' get plotting inverval and rate
  CLS
  MININTERVAL# = 1 / 18.2
  PRINT USING "ENTER INTERVAL (MIN #.######)"; MININTERVAL#;
  INPUT " ", PLOTINTERVAL
  IF PLOTINTERVAL = 0 THEN PLOTINTERVAL = MININTERVAL#
  PLOTRATE = 1 / PLOTINTERVAL
RETURN

GETAVG:                                 ' get averaging
  CLS
  LOCATE 3, 1: INPUT "ENTER AVERAGING (1-5000)"; AVG%
  IF AVG% < 1 OR AVG% > 5000 THEN GOTO GETAVG
RETURN

GETELAPSED:                             ' get elapsed time from start of scan
  IF STARTDAY$ <> DATE$ THEN DAYS = DAYS + 86400: STARTDAY$ = DATE$
  ELAPSEDTIME = TIMER + DAYS - SCANSTART
RETURN

WAITSETTLE:                             ' wait settling time for channel
    GOSUB GETELAPSED
    IF ELAPSEDTIME < SETTLE THEN GOTO WAITSETTLE        ' wait until done
RETURN

GETADC:
  CLS
  PRINT "Enter ADC% or DIP switch setting in binary."  ' prompt for new addr
  PRINT "(For binary, use 1 for ON and 0 for OFF. ";   '   in either binary
  PRINT " Start with switch #7)";                      '     or decimal
  INPUT A$                                   ' enter the new address
  IF LEN(A$) <> 7 THEN GOTO ASSUMEDEC        ' assume decimal if <> 7 chrs
  ADC% = 0                                   ' accumulate weighted binary
  FOR N% = 1 TO 7                            ' 7 bits to add up
  DIGIT% = (2 ^ (7 - N%)) * ABS(VAL(MID$(A$, N%, 1)) - 1)  ' weight the bit
  ADC% = ADC% + DIGIT%                       ' add it to the sum
  NEXT N%                                    ' do all of them
  ADC% = ADC% * 8: A$ = STR$(ADC%)           ' 8-byte boundaries for address
ASSUMEDEC:
  IF LEN(A$) > 4 THEN GOTO GETADC            ' if > 4, invalid
  ADC% = VAL(A$)                             ' assign value input to ADC%
  PRINT "ADC% in decimal="; ADC%,            ' display new value in decimal
  PRINT "ADC% in Hex="; HEX$(ADC%)           ' also display it in hex
  PRINT "Enter space to continue or Esc to re-enter."  ' allow another round
  A$ = INPUT$(1)                             ' select choice
  IF A$ = CHR$(27) THEN GOTO GETADC          ' if Esc, go get a new value
CHECK141:
  GOSUB EXIST141                             ' test for presence of 141
  IF FOUND% THEN RETURN                      ' 141 found at ADC%, all done
  BEEP: PRINT "A Model 141 board was not";   ' beep and display message that
  PRINT " found at address "; ADC%; " (";    '   141 board not found at the
  PRINT HEX$(ADC%); " Hex)"                  '     current address
  PRINT "Enter space to exit program or Esc to re-enter."  ' allow exit here
  A$ = INPUT$(1)                             ' select choice
  IF A$ <> CHR$(27) THEN GOTO EXITSCAN ELSE GOTO GETADC  ' exit or try again
RETURN

EXIST141:
  CLS
  PRINT "Testing for presence of A/D board . . ."  ' print message
  OUT ADC%, 128                              ' make sure not calibrating
  OUT ADC% + 1, 1                            ' assert the FREEZE bit
  IF INP(ADC% + 3) < 128 THEN FOUND% = 0: RETURN   ' CONVERTING bit missing
  OUT ADC% + 1, 0                            ' now remove the FREEZE bit
WAITTIME:
  IF TIMER > 86390! THEN GOTO WAITTIME       ' avoid imminent rollover
  START = TIMER                              ' remember the time
WWATCH:
  IF TIMER < START + 10 AND INP(ADC% + 3) > 127 THEN GOTO WWATCH ' wait and watch
  IF INP(ADC% + 3) > 127 THEN FOUND% = 0: RETURN   ' spurious CONVERTING bit
  OUT ADC% + 1, 0                            ' start conversion if 141 board
  IF INP(ADC% + 3) > 127 THEN FOUND% = 0: RETURN   ' must be a 141
  FOUND% = -1                                ' A/D card appears to be there
RETURN

